(document:surround "/std/frame")
(document:envelop with-translation _ "alterator-install2")

(define all-packages (make-cell '()))
(define all-conflicts (make-cell '()))

(define (name+conflict x)
  (list (woo-get-option x 'name)
        (woo-get-option x 'conflict)))

(define (get-index lst)
  (lambda(x)
    (list-index (lambda (y) (string=? x y)) lst)))

(define (make-all-conflicts)
  (let-values ( ((names conflicts) (unzip2 (map name+conflict (cell-ref all-packages)))))
    (cell-set! all-conflicts (map (get-index names) conflicts))))

(define (summary x)
  (cons (woo-get-option x 'summary (woo-get-option x 'name)) #f))

(define (name x y)
  (and (cdr x)
       (woo-get-option y 'name)))

(define (load-packages)
(woo-catch
   (thunk (woo-list "/apt-profile/install3"))
   (lambda(reason) '())))

(define (write-update)
  (woo-catch/message
   (thunk       (woo-write "/apt-get" 'job "update" 'packages "  ")
                (woo-write "/autoinstall/apt-get" 'job "update" 'packages "  "))))

(hbox
 (spacer)
 (groupbox (_ "Select packages you want to install")
           max-width 300
           max-height 300
           (document:id packages
                        (checklist
                         (when clicked
                           (let* ((num (packages current))
                                  (status (packages checklist-row-item num))
                                  (c-num (list-ref (cell-ref all-conflicts) num)))
                             (and status
                                  (number? c-num)
                                  (packages checklist-row-item c-num)
                                  (begin (document:popup-critical
                                          (format #f (_ "Has conflict with ~S")
                                                  (woo-get-option
                                                   (list-ref (cell-ref all-packages) c-num)
                                                   'summary)))
                                         (packages checklist-row-item num #f))))
					 (if (string=? (woo-get-option
                                                   (list-ref (cell-ref all-packages) (packages current))
                                                   'summary) "Wine@etersoft") 
						   (document:popup-critical
                                                      (_ "Note that this package can be installed on only one machine"))
						   )
					 ))))
 (spacer))

(define (install-packages lst)
  (and  (eq? 'ok (document:popup '/apt
                                 'packages lst
                                 'job "install"))
        (woo-write "/autoinstall/apt-get"
                   'packages (string-join lst " ")
                   'job "install")))
(frame:on-next (thunk
		 (and (> (length (cell-ref all-packages)) 0) 
		(display 2 )
		 (let ((install-list
                       (filter-map name
                                   (packages checklist-rows)
                                   (cell-ref all-packages))))
                  (and (pair? install-list)
                       (or (install-packages install-list) 'cancel))))))

(define (skip-step)
  (if (eq? (global 'frame:direction) 'back)
      (frame:back)
      (frame:next)))


(document:root
 (when loaded
   (write-update)
   (let ((packages-list (load-packages)))
     (cell-set! all-packages packages-list)
     (make-all-conflicts)
     (packages checklist-rows (map summary packages-list)))
     (let ((len (length (cell-ref all-packages))))
                   (and (<= len 1) (skip-step)))

     ))
